FROM ubuntu:18.04

ENV QT_VERSION v5.9.1
ENV QT_CREATOR_VERSION v4.3.1

# Build prerequisites
RUN apt-get -y update && apt-get -y install qtbase5-dev \
	libxcb-xinerama0-dev \
	build-essential

# Other useful tools
RUN apt-get -y update && apt-get -y install tmux \
	wget \
	zip \
	git \
	vim \
    python3-pip

# Simple root password in case we want to customize the container
#RUN echo "root:root" | chpasswd

#RUN useradd -G video -ms /bin/bash user

# Get Python 3.8.3
RUN apt update
RUN apt-get install build-essential zlib1g-dev libncurses5-dev libgdbm-dev libnss3-dev libssl-dev libreadline-dev libffi-dev libsqlite3-dev wget libbz2-dev -y
RUN wget https://www.python.org/ftp/python/3.8.3/Python-3.8.3.tgz
RUN tar -xf Python-3.8.3.tgz && Python-3.8.3
RUN ./configure --enable-optimizations
RUN make
RUN make altinstall
RUN python3.8 --version
RUN cd ..
# Get pip3 < 21.0
#RUN pip3 install --upgrade "pip < 21.0"


WORKDIR /code

# Install requirements
COPY requirements.txt .
RUN python3.8 -m pip install -r requirements.txt
#RUN pip install -r requirements.txt
# Install dependencies for Qt
RUN apt-get install libgl1-mesa-glx -y
RUN apt-get install libxcb-xinerama0-dev -y 
RUN apt-get install libxcb-randr0-dev libxcb-xtest0-dev libxcb-xinerama0-dev libxcb-shape0-dev libxcb-xkb-dev -y
RUN apt-get install libxcb-render-util0 libxcb-randr0 libxcb-keysyms1 libxcb-image0 libxcb-icccm4 libxkbcommon-x11-0 -y
RUN apt-get install ffmpeg libsm6 libxext6 -y
# Copy code
COPY /. .
#RUN apt install deps/libxcb-util1_0.4.0-0ubuntu3_amd64.deb
#RUN apt-get install libxcb-util1 -y
ENV PYTHONUNBUFFERED=1
#RUN ldd /usr/local/lib/python3.8/site-packages/PyQt5/Qt/plugins/platforms/libqxcb.so

# Run Qt
#CMD ["python", "main.py"]